import { Initializable } from '@pilotlab/initializable';
import Result from '@pilotlab/result';
import { Signal } from '@pilotlab/signals';
import { IPromise } from '@pilotlab/result';
import IAnimation from './interfaces/iAnimation';
import { MapList } from '@pilotlab/collections';
import IAnimationEventArgs from './interfaces/iAnimationEventArgs';
import IAnimationValue from './interfaces/iAnimationValue';
import IAnimationEaseFunction from './interfaces/iAnimationEaseFunction';
import AnimationManager from './animationManager';
import IAnimationBatch from './interfaces/iAnimationBatch';
import ISpeed from './interfaces/iSpeed';
import Speed from './speed';
export declare class Animation extends Initializable implements IAnimation {
    constructor(values: IAnimationValue[], duration?: number, ease?: IAnimationEaseFunction, repeatCount?: number, key?: string);
    readonly values: IAnimationValue[];
    private _values;
    readonly result: Result<IAnimation>;
    protected p_result: Result<IAnimation>;
    then(onDone: (value: IAnimation) => void, onError?: (error: Error) => void): IPromise<IAnimation>;
    isTimed: boolean;
    protected p_isTimed: boolean;
    readonly isCompleted: boolean;
    protected p_isCompleted: boolean;
    readonly isInterrupted: boolean;
    protected p_isInterrupted: boolean;
    readonly animationManager: AnimationManager;
    internalAnimationManager: AnimationManager;
    readonly progress: number;
    protected p_progress: number;
    protected p_ease: IAnimationEaseFunction;
    protected p_duration: number;
    protected p_startElapsedMilliseconds: number;
    protected p_elapsedMilliseconds: number;
    protected p_isInitialized: boolean;
    protected p_repeatCount: number;
    readonly key: string;
    protected p_key: string;
    ticked: Signal<IAnimationEventArgs>;
    completed: Signal<IAnimationEventArgs>;
    internalTick(elapsedMilliseconds: number): void;
    protected p_onTicked(args: IAnimationEventArgs): void;
    private _completeAnimation(progress, elapsedMilliseconds, isInterrupted?);
    completeAnimation(isInterrupted?: boolean): void;
    protected p_onCompleted(args: IAnimationEventArgs): void;
    interrupt(): void;
    static readonly animate: AnimationManager;
    private static _animate;
    static readonly animations: MapList<string, IAnimation>;
    private static _animations;
    static speed: Speed;
    private static _timerFPS;
    private static _timerFPSActual;
    static fps: number;
    static readonly fpsActual: number;
    private static _fpsActual;
    private static _frameCount;
    private static _fpsAccum;
    private static _frameAverageCount;
    private static _isRunningInWindow;
    private static _intervalReference;
    private static _isInitialized;
    static initialize(): void;
    static reset(): void;
    private static _onTimerTick();
    private static _tick();
    static validateSpeed(durationSpeed?: (number | ISpeed)): ISpeed;
    static getDuration(durationSpeed?: (number | ISpeed), startValue?: number, targetValue?: number, isNormalizedValue?: boolean, fps?: number): number;
    static go(startValue: number, targetValue: number, durationSpeed?: (number | ISpeed), ease?: IAnimationEaseFunction, repeatCount?: number, animationKey?: string): Animation;
    static goAnimation(animationIn: IAnimation): void;
    static goAnimations(animationsIn: IAnimation[]): IAnimationBatch;
    static pause(durationSpeed?: (number | ISpeed), ease?: IAnimationEaseFunction): Animation;
}
export default Animation;
